#include <stdio.h>
#include <string.h>
#include <StringView.h>
#include "DirWindow.h"
#include "DirList.h"
#include "ListViewerTypes.h"

#define IDC_DIRWINDOW				'ndir'

DirWindow::DirWindow(const char *title,const char *path)
:BWindow(BRect(40,40,270,220),title,B_TITLED_WINDOW,B_NOT_ZOOMABLE)
{
	BView *view;
	BRect rect; //,rect2;
	CDirectoryRow *root;
	float h;
	font_height fh;
	int i,j;
	char buf[100];
	ROWEXPANDDATA expanddata;
	
	view=new BView(Bounds(),"main_view",B_FOLLOW_ALL_SIDES,0);
	view->SetViewColor(216,216,216);

	rect=view->Bounds();
	rect.InsetBy(5,5);
	rect.top=rect.bottom-5;
	selection=new BStringView(rect,"selection_view","This is a test",B_FOLLOW_LEFT_RIGHT|B_FOLLOW_BOTTOM);
	selection->GetFontHeight(&fh);
	view->AddChild(selection);
	h=fh.ascent+fh.descent;
	rect.top=rect.bottom-h;
	selection->MoveTo(rect.left,rect.top);
	selection->ResizeTo(rect.Width(),rect.Height());

	rect=view->Bounds();
	rect.InsetBy(5,5);
	rect.bottom-=h+5;
	list=new CColumnListView(rect,"list_view",B_FOLLOW_ALL_SIDES,0,LISTMODE_SINGLE);
	list->AddColumn(new CStringColumn("Directory",rect.right-rect.left,10,2000),FIELD_DIRECTORY,"Directory");
	root=new CDirectoryRow(list,"/");
	list->AddRow(root);
	list->ExpandRow(root);
	view->AddChild(list);
	AddChild(view);

	list->SetTarget(this,this);
	list->SetMessage(new BMessage(IDC_DIRWINDOW));
	
	// Attempt to traverse the supplied path, in the list
		// Assume the start is always root
	i=0;
	expanddata.directory_name=buf;
	expanddata.window=this;
		// In a loop, process each directory name
	while((path[i]!='\0')&&(root!=NULL)) {
		while(path[i]=='/') i++;
			// Copy the next directory name
		for(j=0;(path[i]!='\0')&&(path[i]!='/');i++,j++)
			buf[j]=path[i];
		buf[j]='\0';
		if(j>0) {
			// Expand it in the list view, if possible
			root=(CDirectoryRow*)list->EachItemUnder(root,true,MatchFunc,&expanddata);
		}
	}
	list->SetCurrentSelection(root,false);
}
DirWindow::~DirWindow()
{
}

CRow* DirWindow::MatchFunc(CRow *row,void *_data)
{
	char name[100];
	ROWEXPANDDATA *data=(ROWEXPANDDATA*)_data;
	
	((CDirectoryRow*)row)->GetName(name);
	if(strcmp(name,data->directory_name)==0) {
		data->window->list->ExpandRow(row);
		return row;
	} else return NULL;
}

void DirWindow::MessageReceived(BMessage *message)
{
	char text[300],buf[300];

	switch(message->what) {
		case IDC_DIRWINDOW:
			((CDirectoryRow*)list->CurrentSelection(0))->GetPath(text);
			sprintf(buf,"Selection : %s",text);
			selection->SetText(buf);
			break;
		default:
			BWindow::MessageReceived(message);
			break;
	}
}
